﻿using System.Collections.Generic;

namespace TestPooling.DirtyList {
  public class PushStack2<T> {
    private readonly List<List<T>> items = new List<List<T>>();
    private bool IsEnabled { get; set; }

    public PushStack2() {
      IsEnabled = true;
    }

    public void Push(T item) {
      if (!IsEnabled) return;

      items[items.Count - 1].Add(item);
    }

    public void PushRange(IEnumerable<T> items) {
      if (!IsEnabled) return;

      this.items.Add(new List<T>(items));
    }

    public T Pop() {
      var container = items[items.Count - 1];

      if (container.Count == 1) {
        items.RemoveAt(items.Count - 1);
      }

      var item = container[container.Count - 1];
      container.RemoveAt(container.Count - 1);

      return item;
    }

    public void Clear() {
      items.Clear();
    }
  }
}
